unit unace;

interface

uses messages,wintypes,winprocs;

function LoadAceDLL:boolean;

const
  ACEERR_MEM=      1;
  ACEERR_FILES=    2;
  ACEERR_FOUND=    3;
  ACEERR_FULL=     4;
  ACEERR_OPEN=     5;
  ACEERR_READ=     6;
  ACEERR_WRITE=    7;
  ACEERR_CLINE=    8;
  ACEERR_CRC=      9;
  ACEERR_OTHER=   10;
  ACEERR_EXISTS=  11;
  ACEERR_END=      128;
  ACEERR_HANDLE=   129;
  ACEERR_CONSTANT= 130;
  ACEERR_NOPASSW=  131;
  ACEERR_METHOD=   132;
  ACEERR_USER=   255;

  ACEOPEN_LIST=    0;
  ACEOPEN_EXTRACT= 1;

  ACECMD_SKIP=     0;
  ACECMD_TEST=     1;
  ACECMD_EXTRACT=  2;

  ACEVOL_REQUEST=  0;
  ACEVOL_OPENED=   1;


  ACESEL_YES=      0;
  ACESEL_ALWAYS=   1;
  ACESEL_NO=       2;
  ACESEL_CANCEL=   3;

  ACECMT_OK=       0;
  ACECMT_SMALLBUF= 1;
  ACECMT_NONE=   255;

type
  pbyte=^byte;
  TChangeVolProc=function(ArcName:pchar;Mode:longint):longint;
  TProcessDataProc=function(Addr:pbyte;Size:longint):longint;

type
  TACEHeaderData=packed record
    ArcName:array [0..259] of char;
    FileName:array [0..259] of char;
    Flags,
    PackSize,
    UnpSize,
    FileCRC,
    FileTime,
    Method,
    QUAL,
    FileAttr:longint;
    CmtBuf:pchar;
    CmtBufSize,
    CmtSize,
    CmtState:longint;
  end;

  tACEOpenArchiveData=packed record
    ArcName:pchar;
    OpenMode,
    OpenResult,
    Flags,
    Host:longint;
    AV:array[0..50] of char;
    CmtBuf:pchar;
    CmtBufSize,
    CmtSize,
    CmtState:longint;
    ChangeVolProc:TChangeVolProc;
    ProcessDataProc:TProcessDataProc;
  end;

type
  TACEOpenArchive=function(var ArchiveData:tACEOpenArchiveData):thandle; stdcall;
  TACECloseArchive=function(hArcData:thandle):longint; stdcall;
  TACEReadHeader=function(hArcData:thandle;var HeaderData:TACEHeaderData):longint; stdcall;
  TACEProcessFile=function(hArcData:thandle;Operation:longint;DestPath:pchar):longint; stdcall;
  TACESetPassword=function(hArcData:thandle;Password:pchar):longint; stdcall;

var
  ACEOpenArchive:TACEOpenArchive;
  ACECloseArchive:TACECloseArchive;
  ACEReadHeader:TACEReadHeader;
  ACEProcessFile:TACEProcessFile;
  ACESetPassword:TACESetPassword;

implementation

uses sysutils;

const AceDllHandle:thandle=0;

function LoadAceDLL:boolean;
const unacedll='unace.dll';
var oldmode:integer;
begin
  if AceDllHandle<>0 then result:=true
  else begin
    oldmode:=SetErrorMode($8001);
    AceDllHandle:=LoadLibrary(unacedll);
    SetErrorMode(oldmode);
    if AceDllHandle<>0 then begin
      @ACEOpenArchive:=GetProcAddress(AceDllHandle,'ACEOpenArchive');
      @ACECloseArchive:=GetProcAddress(AceDllHandle,'ACECloseArchive');
      @ACEReadHeader:=GetProcAddress(AceDllHandle,'ACEReadHeader');
      @ACEProcessFile:=GetProcAddress(AceDllHandle,'ACEProcessFile');
      @ACESetPassword:=GetProcAddress(AceDllHandle,'ACESetPassword');
      if (@ACEOpenArchive=nil) or (@ACECloseArchive=nil) or (@ACEReadHeader=nil) or
         (@ACEProcessFile=nil) or (@ACESetPassword=nil) then begin
        FreeLibrary(AceDllHandle);
        AceDllHandle:=0;
      end;
    end;
    result:=AceDllHandle<>0;
  end;
end;

initialization
finalization
  if AceDllHandle<>0 then
    FreeLibrary(AceDllHandle);
  AceDllHandle:=0;
end.
